package com.dsk.flink.dsc.utils;

import cn.hutool.core.util.StrUtil;

import java.util.Properties;

public class EtlUtils {

    public static Properties getKafkaConfig(String url, String groupId, String username, String password) {
        Properties properties = new Properties();
        properties.setProperty("bootstrap.servers", url);
        properties.setProperty("group.id", groupId);
        properties.setProperty("key.deserializer", "org.apache.kafka.common.serialization.StringDeserializer");
        properties.setProperty("value.deserializer", "org.apache.kafka.common.serialization.StringDeserializer");
        properties.setProperty("auto.offset.reset", "earliest");
        properties.setProperty("sasl.jaas.config", getSaslJaasConfig(username,password));
        properties.setProperty("security.protocol", "SASL_PLAINTEXT");
        properties.setProperty("sasl.mechanism", "SCRAM-SHA-512");
        properties.setProperty("fetch.max.bytes", "1048576"); //1M
        properties.setProperty("flink.consumer.max.fetch.size", "524288");//512k
        properties.setProperty("session.timeout.ms", "30000");
        properties.setProperty("heartbeat.interval.ms", "10000");
        properties.setProperty("request.timeout.ms", "60000");
        properties.setProperty("retries", "3");
        properties.setProperty("retry.backoff.ms", "5000");
        properties.setProperty("receive.buffer.bytes", "65536"); //64k
        properties.setProperty("max.poll.records", "10");

        return properties;
    }

    public static String getSaslJaasConfig(String username, String password){
        String saslJaasConfig = "org.apache.kafka.common.security.scram.ScramLoginModule required username=\"%s\" password=\"%s\";";
        return String.format(saslJaasConfig, username, password);
    }

    public static String getKafkaGroup(EnvProperties envProps){
        //return "test";
        return envProps.getKafka_topic().concat(StrUtil.isNotBlank(envProps.getEnv()) ? envProps.getEnv() : "").concat("-group");
    }

    /*public static void main(String[] args) {
        System.out.println(getSaslJaasConfig("szx","123456"));
    }*/
}
